# SYMBIAN_UID = 0x101FF30C
__author__  = "Matt Croydon <matt@ooiio.com> - http://postneo.com"
__version__ = "0.0.6 (Big Thunder Mountain)"
__license__ = "GPL"
__copyright__ = "Copyright (c) 2005 Matt Croydon.  Requires dictclient.py Copyright (c) 2002 John Goerzen."

import appuifw
import e32
import dictclient #John Goerzen's GPL'd dictclient.py

e32.ao_yield()

class Dict2Go:
	def __init__(self):
		self.lock = e32.Ao_lock()

		self.old_title = appuifw.app.title
		appuifw.app.title = u"Dict2Go"

		self.exit_flag = False
		appuifw.app.exit_key_handler = self.abort

		self.word = u''

		self.get_word()
		self.lookup_word()

	def abort(self):
		# Exit-key handler.
		self.exit_flag = True
		self.lock.signal()

	def get_word(self):
		self.word = appuifw.query(u'Enter a word to define', 'text')

	def lookup_word(self):
		text = u'Looking up %s' % self.word
		appuifw.note(text, 'info')
		# dict server hard wired for now
		conn = dictclient.Connection('dict.org')
		# ! gets first hit, * for all hits later
		defs = conn.define('!', self.word)
		self.response_text = appuifw.Text()
		self.response_text.set(unicode(defs[0].getdefstr(), 'ascii'))
		self.response_text.set_pos(0)
		appuifw.app.body = self.response_text
		self.lock.wait()
			
def main():
	app = Dict2Go()
  
if __name__ == "__main__":
	main()
